notify_host_by_email.sh 3.2 KB

123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109110111112113114115116117118119120121122123124125126127128129130131132133134135136137138139140141142143144145146147148149150151152153154155
  1. #! /bin/bash
  2. #
  3. # Nagios host notification script.
  4. #
  5. # Copyright (C) 2012 Sebastian 'tokkee' Harl <sh@teamix.net>
  6. # and teamix GmbH, Nuernberg, Germany
  7. #
  8. # This file is part of "teamix Monitoring Plugins"
  9. # URL: http://oss.teamix.org/projects/monitoringplugins/
  10. #
  11. # This file is free software: you can redistribute it and/or modify
  12. # it under the terms of the GNU General Public License as published
  13. # by the Free Software Foundation, either version 2 of the License,
  14. # or (at your option) any later version.
  15. #
  16. # This file is distributed in the hope that it will be useful, but
  17. # WITHOUT ANY WARRANTY; without even the implied warranty of
  18. # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
  19. # GNU General Public License for more details.
  20. #
  21. # You should have received a copy of the GNU General Public License
  22. # along with this file. If not, see <http://www.gnu.org/licenses/>.
  23. #
  24. # Sample command line:
  25. # notify_host_by_email.sh -T '$NOTIFICATIONTYPE$' -H '$HOSTNAME$' \
  26. # -a '$HOSTALIAS$' -A '$HOSTADDRESS$' \
  27. # -s '$HOSTSTATE$' \
  28. # -o '$HOSTOUTPUT$' -O '$LONGHOSTOUTPUT$' \
  29. # -P '$HOSTPERFDATA$' -D '$LONGDATETIME$' \
  30. # -E '$CONTACTEMAIL$'
  31. #
  32. NOTIFICATIONTYPE="UNKNOWN"
  33. HOSTNAME="unknown host"
  34. HOSTALIAS=""
  35. HOSTADDRESS=""
  36. HOSTSTATE="UNKNOWN"
  37. HOSTOUTPUT=""
  38. LONGHOSTOUTPUT=""
  39. HOSTPERFDATA=""
  40. LONGDATETIME=`date`
  41. CONTACTEMAIL=""
  42. GETOPT=$( getopt -o T:H:a:A:s:o:O:P:D:E: \
  43. --long type,hostname,alias,address,state,output,longoutput,perfdata,datetime,email \
  44. -n 'notify_host_by_email' -- "$@" )
  45. if test $? -ne 0; then
  46. echo 'Failed to parse command line options!' >&2
  47. exit 1
  48. fi
  49. eval set -- "$GETOPT"
  50. while true; do
  51. case "$1" in
  52. -T|--type)
  53. NOTIFICATIONTYPE="$2"
  54. shift 2
  55. ;;
  56. -H|--hostname)
  57. HOSTNAME="$2"
  58. shift 2
  59. ;;
  60. -a|--alias)
  61. HOSTALIAS="$2"
  62. shift 2
  63. ;;
  64. -A|--address)
  65. HOSTADDRESS="$2"
  66. shift 2
  67. ;;
  68. -s|--state)
  69. HOSTSTATE="$2"
  70. shift 2
  71. ;;
  72. -o|--output)
  73. HOSTOUTPUT="$2"
  74. shift 2
  75. ;;
  76. -O|--longoutput)
  77. LONGHOSTOUTPUT="$2"
  78. shift 2
  79. ;;
  80. -P|--perfdata)
  81. HOSTPERFDATA="$2"
  82. shift 2
  83. ;;
  84. -D|--datetime)
  85. LONGDATETIME="$2"
  86. shift 2
  87. ;;
  88. -E|--email)
  89. CONTACTEMAIL="$2"
  90. shift 2
  91. ;;
  92. --)
  93. shift
  94. break
  95. ;;
  96. esac
  97. done
  98. if test -z "$CONTACTEMAIL"; then
  99. echo 'Missing contact email!' >&2
  100. exit 1
  101. fi
  102. EMAIL=$( mktemp -t )
  103. trap "rm -f $EMAIL" EXIT
  104. function email_append() {
  105. /usr/bin/printf "%b" "$@" "\n" >> $EMAIL
  106. }
  107. cat <<EOF > $EMAIL
  108. ***** Nagios *****
  109. Notification Type: $NOTIFICATIONTYPE
  110. Host: $HOSTNAME ($HOSTALIAS)
  111. EOF
  112. if test -n "$HOSTADDRESS"; then
  113. email_append "Address: $HOSTADDRESS"
  114. fi
  115. email_append "State: $HOSTSTATE"
  116. if test -n "$HOSTOUTPUT"; then
  117. email_append "Info: $HOSTOUTPUT"
  118. fi
  119. email_append ""
  120. email_append "Date/Time: $LONGDATETIME"
  121. if test -n "$LONGHOSTOUTPUT"; then
  122. email_append ""
  123. email_append "Additional Info:"
  124. email_append ""
  125. email_append "$LONGHOSTOUTPUT"
  126. fi
  127. if test -n "$HOSTPERFDATA"; then
  128. email_append ""
  129. email_append "Performance Data:"
  130. email_append ""
  131. email_append "$HOSTPERFDATA"
  132. fi
  133. cat $EMAIL | /usr/bin/mail -s "** $NOTIFICATIONTYPE Host Alert: $HOSTNAME is $HOSTSTATE **" $CONTACTEMAIL